// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.pmfm;

import fr.ifremer.adagio.core.dao.referential.Status;
import java.io.Serializable;

/**
 * Liste des valeurs qualitatives que peut prendre un paramètre.
 * Par exemple :
 * - pour le paramètre Sexe : "Mâle" et "Femelle"
 * - pour le paramètre Présentation : "Vidé", "Entier", ...
 * - pour le paramètre Catégorie : "Gros", "Moyen", ...
 */
// HibernateEntity.vsl annotations merge-point
public abstract class QualitativeValue
    implements Serializable, Comparable<QualitativeValue>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 5496324654886304455L;

    // Generate 3 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String name;

    /**
     * 
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * 
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    // Generate 19 associations
    private Status status;

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @return this.status Status
     */
    public Status getStatus()
    {
        return this.status;
    }

    /**
     * Pour les données du référentiel, information permettant de déterminer si une donnée est
     * valide,
     * obsolète ou temporaire.
     * - obsolète (=inactif) : '0'
     * - valide (=actif) : '1'
     * - temporaire : '2'
     * note : on a préfère ici 'valide' au terme 'actif' (utilisé dans Harmonie), pour ne pas
     * confondre
     * avec par exemple l'activité d'un navire sur un mois.
     * @param statusIn Status
     */
    public void setStatus(Status statusIn)
    {
        this.status = statusIn;
    }

    private Parameter parameter;

    /**
     * Un paramètre est une propriété du milieu ou d'un élément du milieu qui contribue à en
     * apprécier les
     * caractéristiques et/ou la qualité et/ou l'aptitude à des usages.
     * Le paramètre se décline en trois types : quantitatif, qualitatif ou libre.
     * Le type quantitatif se rapporte aux paramètres qui ont une infinité de résultats numériques.
     * Le type qualitatif se rapporte aux paramètres qui ne prennent qu'un nombre limité de valeurs
     * prédéfinies pour chacun d'eux.
     * Le type libre, ou alphanumérique, correspond aux paramètres de valeurs alphanumériques, sans
     * limite
     * de valeurs possibles (hormis la longueur de la chaine : 40 max).
     * Ces trois types sont mutuellement exclusifs.
     * Exemple de paramètre :
     * • Taille (numérique)
     * • Age (numérique)
     * • Sexe (qualitatif)
     * • Catégorie commerciale (qualitatif)
     * • Présentation commerciale (qualitatif)
     * • Vrac / Hors Vrac (qualitatif)
     * • Rejet / Débarquement (qualitatif) (Discard/Landing)
     * • Stade de maturité (qualitatif) (Maturity stage)
     * • Numéro de contrat (libre - alphanumérique)
     * Cette liste n’est pas exhaustive.
     * Nombre de lignes : 130
     * @return this.parameter Parameter
     */
    public Parameter getParameter()
    {
        return this.parameter;
    }

    /**
     * Un paramètre est une propriété du milieu ou d'un élément du milieu qui contribue à en
     * apprécier les
     * caractéristiques et/ou la qualité et/ou l'aptitude à des usages.
     * Le paramètre se décline en trois types : quantitatif, qualitatif ou libre.
     * Le type quantitatif se rapporte aux paramètres qui ont une infinité de résultats numériques.
     * Le type qualitatif se rapporte aux paramètres qui ne prennent qu'un nombre limité de valeurs
     * prédéfinies pour chacun d'eux.
     * Le type libre, ou alphanumérique, correspond aux paramètres de valeurs alphanumériques, sans
     * limite
     * de valeurs possibles (hormis la longueur de la chaine : 40 max).
     * Ces trois types sont mutuellement exclusifs.
     * Exemple de paramètre :
     * • Taille (numérique)
     * • Age (numérique)
     * • Sexe (qualitatif)
     * • Catégorie commerciale (qualitatif)
     * • Présentation commerciale (qualitatif)
     * • Vrac / Hors Vrac (qualitatif)
     * • Rejet / Débarquement (qualitatif) (Discard/Landing)
     * • Stade de maturité (qualitatif) (Maturity stage)
     * • Numéro de contrat (libre - alphanumérique)
     * Cette liste n’est pas exhaustive.
     * Nombre de lignes : 130
     * @param parameterIn Parameter
     */
    public void setParameter(Parameter parameterIn)
    {
        this.parameter = parameterIn;
    }

    /**
     * Returns <code>true</code> if the argument is an QualitativeValue instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof QualitativeValue))
        {
            return false;
        }
        final QualitativeValue that = (QualitativeValue)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link QualitativeValue}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link QualitativeValue}.
         * @return new QualitativeValueImpl()
         */
        public static QualitativeValue newInstance()
        {
            return new QualitativeValueImpl();
        }

        /**
         * Constructs a new instance of {@link QualitativeValue}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param name String
         * @param status Status
         * @param parameter Parameter
         * @return newInstance
         */
        public static QualitativeValue newInstance(String name, Status status, Parameter parameter)
        {
            final QualitativeValue entity = new QualitativeValueImpl();
            entity.setName(name);
            entity.setStatus(status);
            entity.setParameter(parameter);
            return entity;
        }

        /**
         * Constructs a new instance of {@link QualitativeValue}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param name String
         * @param description String
         * @param status Status
         * @param parameter Parameter
         * @return newInstance QualitativeValue
         */
        public static QualitativeValue newInstance(String name, String description, Status status, Parameter parameter)
        {
            final QualitativeValue entity = new QualitativeValueImpl();
            entity.setName(name);
            entity.setDescription(description);
            entity.setStatus(status);
            entity.setParameter(parameter);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(QualitativeValue o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// QualitativeValue.java merge-point
}